<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>. lekce</title>
</head>
<body>

    <div id="root" style="display: flex;">
        <div id="products" style="width: 80%;"></div>

        <div id="basket" style="width: 20%; position: fixed; right: 0;"></div>
    </div>

    <style>
        .hide {
            display: none;
        }

        .product {
            display: flex;
            align-items: center;
            flex-direction: column;
            font-size: 24px;
            gap: 10px;
            margin-bottom: 20px;
        }
    </style>

    <script>
        (async function() {
            const delay = ms => new Promise(res => setTimeout(res, ms));

            const productElement = document.getElementById("products");

            const url = "https://raw.githubusercontent.com/pavelprokes/js-demo-test/master/vzdelani-budoucnosti/javascript/products.json"

            let basket = [];

            async function getProducts() {
                await delay(2000);

                const data = await fetch(url)
                    .catch(error => {
                        console.log(`Error when fetching products from ${url} error: ${JSON(error)}.`);
                    })
                    .then(response => {
                        const jsonData = response.json();
                        return jsonData;
                    });

                return data;
            }
          
            function createLoader() {
                const loaderElement = document.createElement("div");
                loaderElement.setAttribute("id", "loader");
                const loaderText = document.createTextNode("Please wait ...");
                loaderElement.appendChild(loaderText);
                productElement.appendChild(loaderElement);
            }

            function hideLoader() {
                const loader = document.getElementById("loader");
                loader.classList.add("hide");
            }

            function addToBasket(productId, productList) {
                //basket.push(productId);

                //basket = [1, 1, 1, 2, 2]
                //newbasket = [{ productId: 1, quantity: 3 }, { productId: 2, quantity: 2 }]

                basket.reduce((accumulator, currentValue) => {
                    const currentProduct = accumulator.find(cp => cp.productId === productId);

                    console.log(currentProduct);

                    if (currentProduct) {
                        return [...accumulator, { productId, quantity: currentProduct.quantity + 1}]
                    }

                    return [...accumulator, { productId, quantity: 1 }]
                }, [])

                console.log(basket);

                renderBasketItems(basket, productList);
            }

            function renderProductsList(list) {
                const ulElement = document.createElement("ul");

                list.forEach((product, index) => {
                    const liElement = document.createElement("li");
                    liElement.classList.add("product");
                    const textTitle = document.createTextNode(product.title);

                    const buttonElement = document.createElement("button");
                    buttonElement.onclick = function() {
                        addToBasket(product.id, list);
                    };
                    buttonElement.textContent = "Add to basket";

                    const imageElement = document.createElement("img");
                    imageElement.setAttribute("src", product.thumbnail);
                    imageElement.setAttribute("height", 200);

                    liElement.appendChild(textTitle);
                    liElement.appendChild(buttonElement);
                    liElement.appendChild(imageElement);
                    ulElement.appendChild(liElement);
                })

                productElement.appendChild(ulElement);
            }

            createLoader();
            const data = await getProducts();
            
            renderProductsList(data.products);

            hideLoader();

            function renderBasketItems(basket, productList) {
                const basketElement = document.getElementById("basket");
                const currentBasketListElement = document.querySelector("#basket ul");
                if (currentBasketListElement) {
                    currentBasketListElement.remove();
                }

                const basketListElement = document.createElement("ul");

                basket.forEach((productId) => {
                    const product = productList.find((productListItem) => productListItem.id === productId);

                    const basketLiElement = document.createElement("li");
                    const basketItemText = document.createTextNode(product.title);

                    basketLiElement.appendChild(basketItemText);
                    basketListElement.appendChild(basketLiElement);
                })

                basketElement.appendChild(basketListElement);
            }

            console.log([1, 2, 3]
            .reduce(
                (accumulator, currentValue, index) => {
                    return [...accumulator, currentValue + 1]
                },
                []
                )
                )


        })();
    </script>

</body>
</html>